package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TWarningThresholdHistoryExample {
    /**
     * t_warning_threshold_history
     */
    protected String orderByClause;

    /**
     * t_warning_threshold_history
     */
    protected boolean distinct;

    /**
     * t_warning_threshold_history
     */
    protected List<Criteria> oredCriteria;

    public TWarningThresholdHistoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_warning_threshold_history 2019-06-27
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andWModuleIsNull() {
            addCriterion("w_module is null");
            return (Criteria) this;
        }

        public Criteria andWModuleIsNotNull() {
            addCriterion("w_module is not null");
            return (Criteria) this;
        }

        public Criteria andWModuleEqualTo(String value) {
            addCriterion("w_module =", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotEqualTo(String value) {
            addCriterion("w_module <>", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleGreaterThan(String value) {
            addCriterion("w_module >", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleGreaterThanOrEqualTo(String value) {
            addCriterion("w_module >=", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleLessThan(String value) {
            addCriterion("w_module <", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleLessThanOrEqualTo(String value) {
            addCriterion("w_module <=", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleLike(String value) {
            addCriterion("w_module like", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotLike(String value) {
            addCriterion("w_module not like", value, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleIn(List<String> values) {
            addCriterion("w_module in", values, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotIn(List<String> values) {
            addCriterion("w_module not in", values, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleBetween(String value1, String value2) {
            addCriterion("w_module between", value1, value2, "wModule");
            return (Criteria) this;
        }

        public Criteria andWModuleNotBetween(String value1, String value2) {
            addCriterion("w_module not between", value1, value2, "wModule");
            return (Criteria) this;
        }

        public Criteria andWNameIsNull() {
            addCriterion("w_name is null");
            return (Criteria) this;
        }

        public Criteria andWNameIsNotNull() {
            addCriterion("w_name is not null");
            return (Criteria) this;
        }

        public Criteria andWNameEqualTo(String value) {
            addCriterion("w_name =", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotEqualTo(String value) {
            addCriterion("w_name <>", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameGreaterThan(String value) {
            addCriterion("w_name >", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameGreaterThanOrEqualTo(String value) {
            addCriterion("w_name >=", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameLessThan(String value) {
            addCriterion("w_name <", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameLessThanOrEqualTo(String value) {
            addCriterion("w_name <=", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameLike(String value) {
            addCriterion("w_name like", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotLike(String value) {
            addCriterion("w_name not like", value, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameIn(List<String> values) {
            addCriterion("w_name in", values, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotIn(List<String> values) {
            addCriterion("w_name not in", values, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameBetween(String value1, String value2) {
            addCriterion("w_name between", value1, value2, "wName");
            return (Criteria) this;
        }

        public Criteria andWNameNotBetween(String value1, String value2) {
            addCriterion("w_name not between", value1, value2, "wName");
            return (Criteria) this;
        }

        public Criteria andWThresholdIsNull() {
            addCriterion("w_threshold is null");
            return (Criteria) this;
        }

        public Criteria andWThresholdIsNotNull() {
            addCriterion("w_threshold is not null");
            return (Criteria) this;
        }

        public Criteria andWThresholdEqualTo(BigDecimal value) {
            addCriterion("w_threshold =", value, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdNotEqualTo(BigDecimal value) {
            addCriterion("w_threshold <>", value, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdGreaterThan(BigDecimal value) {
            addCriterion("w_threshold >", value, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("w_threshold >=", value, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdLessThan(BigDecimal value) {
            addCriterion("w_threshold <", value, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("w_threshold <=", value, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdIn(List<BigDecimal> values) {
            addCriterion("w_threshold in", values, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdNotIn(List<BigDecimal> values) {
            addCriterion("w_threshold not in", values, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("w_threshold between", value1, value2, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andWThresholdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("w_threshold not between", value1, value2, "wThreshold");
            return (Criteria) this;
        }

        public Criteria andThresholdIsNull() {
            addCriterion("threshold is null");
            return (Criteria) this;
        }

        public Criteria andThresholdIsNotNull() {
            addCriterion("threshold is not null");
            return (Criteria) this;
        }

        public Criteria andThresholdEqualTo(BigDecimal value) {
            addCriterion("threshold =", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdNotEqualTo(BigDecimal value) {
            addCriterion("threshold <>", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdGreaterThan(BigDecimal value) {
            addCriterion("threshold >", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("threshold >=", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdLessThan(BigDecimal value) {
            addCriterion("threshold <", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("threshold <=", value, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdIn(List<BigDecimal> values) {
            addCriterion("threshold in", values, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdNotIn(List<BigDecimal> values) {
            addCriterion("threshold not in", values, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("threshold between", value1, value2, "threshold");
            return (Criteria) this;
        }

        public Criteria andThresholdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("threshold not between", value1, value2, "threshold");
            return (Criteria) this;
        }

        public Criteria andWStateIsNull() {
            addCriterion("w_state is null");
            return (Criteria) this;
        }

        public Criteria andWStateIsNotNull() {
            addCriterion("w_state is not null");
            return (Criteria) this;
        }

        public Criteria andWStateEqualTo(Integer value) {
            addCriterion("w_state =", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateNotEqualTo(Integer value) {
            addCriterion("w_state <>", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateGreaterThan(Integer value) {
            addCriterion("w_state >", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateGreaterThanOrEqualTo(Integer value) {
            addCriterion("w_state >=", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateLessThan(Integer value) {
            addCriterion("w_state <", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateLessThanOrEqualTo(Integer value) {
            addCriterion("w_state <=", value, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateIn(List<Integer> values) {
            addCriterion("w_state in", values, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateNotIn(List<Integer> values) {
            addCriterion("w_state not in", values, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateBetween(Integer value1, Integer value2) {
            addCriterion("w_state between", value1, value2, "wState");
            return (Criteria) this;
        }

        public Criteria andWStateNotBetween(Integer value1, Integer value2) {
            addCriterion("w_state not between", value1, value2, "wState");
            return (Criteria) this;
        }

        public Criteria andWTimeIsNull() {
            addCriterion("w_time is null");
            return (Criteria) this;
        }

        public Criteria andWTimeIsNotNull() {
            addCriterion("w_time is not null");
            return (Criteria) this;
        }

        public Criteria andWTimeEqualTo(Date value) {
            addCriterion("w_time =", value, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeNotEqualTo(Date value) {
            addCriterion("w_time <>", value, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeGreaterThan(Date value) {
            addCriterion("w_time >", value, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("w_time >=", value, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeLessThan(Date value) {
            addCriterion("w_time <", value, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeLessThanOrEqualTo(Date value) {
            addCriterion("w_time <=", value, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeIn(List<Date> values) {
            addCriterion("w_time in", values, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeNotIn(List<Date> values) {
            addCriterion("w_time not in", values, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeBetween(Date value1, Date value2) {
            addCriterion("w_time between", value1, value2, "wTime");
            return (Criteria) this;
        }

        public Criteria andWTimeNotBetween(Date value1, Date value2) {
            addCriterion("w_time not between", value1, value2, "wTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeIsNull() {
            addCriterion("w_update_time is null");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeIsNotNull() {
            addCriterion("w_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeEqualTo(Date value) {
            addCriterion("w_update_time =", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeNotEqualTo(Date value) {
            addCriterion("w_update_time <>", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeGreaterThan(Date value) {
            addCriterion("w_update_time >", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("w_update_time >=", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeLessThan(Date value) {
            addCriterion("w_update_time <", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("w_update_time <=", value, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeIn(List<Date> values) {
            addCriterion("w_update_time in", values, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeNotIn(List<Date> values) {
            addCriterion("w_update_time not in", values, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("w_update_time between", value1, value2, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andWUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("w_update_time not between", value1, value2, "wUpdateTime");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andWRemarkIsNull() {
            addCriterion("w_remark is null");
            return (Criteria) this;
        }

        public Criteria andWRemarkIsNotNull() {
            addCriterion("w_remark is not null");
            return (Criteria) this;
        }

        public Criteria andWRemarkEqualTo(String value) {
            addCriterion("w_remark =", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkNotEqualTo(String value) {
            addCriterion("w_remark <>", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkGreaterThan(String value) {
            addCriterion("w_remark >", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("w_remark >=", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkLessThan(String value) {
            addCriterion("w_remark <", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkLessThanOrEqualTo(String value) {
            addCriterion("w_remark <=", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkLike(String value) {
            addCriterion("w_remark like", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkNotLike(String value) {
            addCriterion("w_remark not like", value, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkIn(List<String> values) {
            addCriterion("w_remark in", values, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkNotIn(List<String> values) {
            addCriterion("w_remark not in", values, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkBetween(String value1, String value2) {
            addCriterion("w_remark between", value1, value2, "wRemark");
            return (Criteria) this;
        }

        public Criteria andWRemarkNotBetween(String value1, String value2) {
            addCriterion("w_remark not between", value1, value2, "wRemark");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNull() {
            addCriterion("updatetime is null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNotNull() {
            addCriterion("updatetime is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeEqualTo(Date value) {
            addCriterion("updatetime =", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotEqualTo(Date value) {
            addCriterion("updatetime <>", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThan(Date value) {
            addCriterion("updatetime >", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("updatetime >=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThan(Date value) {
            addCriterion("updatetime <", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThanOrEqualTo(Date value) {
            addCriterion("updatetime <=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIn(List<Date> values) {
            addCriterion("updatetime in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotIn(List<Date> values) {
            addCriterion("updatetime not in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeBetween(Date value1, Date value2) {
            addCriterion("updatetime between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotBetween(Date value1, Date value2) {
            addCriterion("updatetime not between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andIsSendIsNull() {
            addCriterion("is_send is null");
            return (Criteria) this;
        }

        public Criteria andIsSendIsNotNull() {
            addCriterion("is_send is not null");
            return (Criteria) this;
        }

        public Criteria andIsSendEqualTo(String value) {
            addCriterion("is_send =", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendNotEqualTo(String value) {
            addCriterion("is_send <>", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendGreaterThan(String value) {
            addCriterion("is_send >", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendGreaterThanOrEqualTo(String value) {
            addCriterion("is_send >=", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendLessThan(String value) {
            addCriterion("is_send <", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendLessThanOrEqualTo(String value) {
            addCriterion("is_send <=", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendLike(String value) {
            addCriterion("is_send like", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendNotLike(String value) {
            addCriterion("is_send not like", value, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendIn(List<String> values) {
            addCriterion("is_send in", values, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendNotIn(List<String> values) {
            addCriterion("is_send not in", values, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendBetween(String value1, String value2) {
            addCriterion("is_send between", value1, value2, "isSend");
            return (Criteria) this;
        }

        public Criteria andIsSendNotBetween(String value1, String value2) {
            addCriterion("is_send not between", value1, value2, "isSend");
            return (Criteria) this;
        }

        public Criteria andWModeIsNull() {
            addCriterion("w_mode is null");
            return (Criteria) this;
        }

        public Criteria andWModeIsNotNull() {
            addCriterion("w_mode is not null");
            return (Criteria) this;
        }

        public Criteria andWModeEqualTo(String value) {
            addCriterion("w_mode =", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeNotEqualTo(String value) {
            addCriterion("w_mode <>", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeGreaterThan(String value) {
            addCriterion("w_mode >", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeGreaterThanOrEqualTo(String value) {
            addCriterion("w_mode >=", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeLessThan(String value) {
            addCriterion("w_mode <", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeLessThanOrEqualTo(String value) {
            addCriterion("w_mode <=", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeLike(String value) {
            addCriterion("w_mode like", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeNotLike(String value) {
            addCriterion("w_mode not like", value, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeIn(List<String> values) {
            addCriterion("w_mode in", values, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeNotIn(List<String> values) {
            addCriterion("w_mode not in", values, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeBetween(String value1, String value2) {
            addCriterion("w_mode between", value1, value2, "wMode");
            return (Criteria) this;
        }

        public Criteria andWModeNotBetween(String value1, String value2) {
            addCriterion("w_mode not between", value1, value2, "wMode");
            return (Criteria) this;
        }

        public Criteria andWWarningIsNull() {
            addCriterion("w_warning is null");
            return (Criteria) this;
        }

        public Criteria andWWarningIsNotNull() {
            addCriterion("w_warning is not null");
            return (Criteria) this;
        }

        public Criteria andWWarningEqualTo(String value) {
            addCriterion("w_warning =", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningNotEqualTo(String value) {
            addCriterion("w_warning <>", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningGreaterThan(String value) {
            addCriterion("w_warning >", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningGreaterThanOrEqualTo(String value) {
            addCriterion("w_warning >=", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningLessThan(String value) {
            addCriterion("w_warning <", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningLessThanOrEqualTo(String value) {
            addCriterion("w_warning <=", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningLike(String value) {
            addCriterion("w_warning like", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningNotLike(String value) {
            addCriterion("w_warning not like", value, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningIn(List<String> values) {
            addCriterion("w_warning in", values, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningNotIn(List<String> values) {
            addCriterion("w_warning not in", values, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningBetween(String value1, String value2) {
            addCriterion("w_warning between", value1, value2, "wWarning");
            return (Criteria) this;
        }

        public Criteria andWWarningNotBetween(String value1, String value2) {
            addCriterion("w_warning not between", value1, value2, "wWarning");
            return (Criteria) this;
        }
    }

    /**
     * t_warning_threshold_history
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_warning_threshold_history 2019-06-27
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}